<?php
namespace Planejamento\Repositories;

class Consserv extends \Doctrine\ORM\EntityRepository
{

    
    public function verificaConsumo(
            $nrorg, $filial, $servico, $dtInicial, $dtFinal, $dtConsumo
    ){
        $sql = "  SELECT DTDATA
                    FROM DATA, PARAMFILIAL PF, PARAMGERAL PG
                  WHERE PG.NRORG = :P_NRORG
                    AND PG.CDFILIAL = :P_CDFILIAL
                    AND PF.CDFILIAL = PG.CDFILIAL
                    AND PF.NRORG = PG.NRORG
                    AND DTDATA BETWEEN (DECODE(PG.IDUTILDTPROC, 'S', DECODE(TO_CHAR(TO_DATE(PF.DTPROCESSA), 'mm'), TO_CHAR(TO_DATE(:P_DTINICIAL), 'mm'),
                                                                    PF.DTPROCESSA, :P_DTINICIAL), :P_DTINICIAL) + NVL(PG.QTDIABLOQCAR, 0)) and :P_DATAFINAL
                  AND NOT EXISTS(
                  SELECT DTCONSSERV FROM (
                  SELECT DTFERIFILI AS DTCONSSERV, RPAD('F',1,' ') AS IDTIPOCONS
                  FROM   FERIFILI F, PARAMPLANEJA P
                  WHERE  F.CDFILIAL = :P_CDFILIAL  AND
                         F.NRORG = :P_NRORG AND
                         F.DTFERIFILI BETWEEN :P_DTCONSSERV AND :P_ULTIDIAMES AND
                         P.CDFILIAL = :P_CDFILIAL  AND
                         P.NRORG = F.NRORG AND
                         NVL(P.IDCARDIAUTIL,'N') = 'S'

                  UNION ALL

                  SELECT CONS.DTCONSSERV, CONS.IDTIPOCONS
                  FROM   (SELECT D.DTCONSSERV, D.IDTIPOCONS
                          FROM   (SELECT DTDATA AS DTCONSSERV, TO_CHAR(DTDATA,'D') IDTIPOCONS
                                  FROM   DATA
                                  WHERE  DTDATA BETWEEN :P_DTCONSSERV AND :P_ULTIDIAMES
                                    AND NRORG = :P_NRORG) D,
                                 (SELECT DTCONSSERV, IDTIPOCONS
                                  FROM   CONSSERV
                                  WHERE  CDFILIAL   = :P_CDFILIAL      AND
                                         CDSERVFILI = :P_CDSERVFILI    AND
                                         NRORG      = :P_NRORG         AND 
                                         NOT IDTIPOCONS IN ('9','8') AND
                                         DTCONSSERV = (SELECT MAX(DTCONSSERV)
                                                       FROM   CONSSERV
                                                       WHERE  CDFILIAL    = :P_CDFILIAL    AND
                                                              CDSERVFILI  = :P_CDSERVFILI  AND
                                                              DTCONSSERV <= :P_DTCONSSERV  AND
                                                              NRORG       = :P_NRORG       AND
                                                              NOT IDTIPOCONS IN ('9','8'))) C
                          WHERE D.IDTIPOCONS = C.IDTIPOCONS
                          UNION
                          SELECT E.DTCONSSERV, E.IDTIPOCONS
                          FROM   (SELECT DTFERICARD AS DTCONSSERV, RPAD('8',1,' ') AS IDTIPOCONS
                                  FROM   FERICARD
                                  WHERE  CDFILIAL = :P_CDFILIAL AND
                                  NRORG = :P_NRORG AND 
                                  DTFERICARD BETWEEN :P_DTCONSSERV AND :P_ULTIDIAMES) E,
                                 (SELECT DTCONSSERV, IDTIPOCONS
                                  FROM   CONSSERV
                                  WHERE  CDFILIAL   = :P_CDFILIAL   AND
                                         CDSERVFILI = :P_CDSERVFILI AND
                                         IDTIPOCONS = '8' AND
                                         NRORG      = :P_NRORG AND 
                                         DTCONSSERV = (SELECT MAX(DTCONSSERV)
                                                       FROM   CONSSERV
                                                       WHERE  CDFILIAL    =  :P_CDFILIAL   AND
                                                              CDSERVFILI  =  :P_CDSERVFILI AND
                                                              DTCONSSERV <= :P_DTCONSSERV  AND
                                                              NRORG       = :P_NRORG AND 
                                                              IDTIPOCONS  = '8')) F
                          WHERE F.IDTIPOCONS = E.IDTIPOCONS
                          UNION
                          SELECT DTCONSSERV, IDTIPOCONS
                          FROM   CONSSERV
                          WHERE  CDFILIAL   = :P_CDFILIAL   AND
                                 CDSERVFILI = :P_CDSERVFILI AND
                                 IDTIPOCONS = '9'           AND
                                 NRORG      = :P_NRORG      AND 
                                 DTCONSSERV BETWEEN :P_DTCONSSERV AND :P_ULTIDIAMES
                          UNION
                          SELECT DTSCONSSERV AS DTCONSSERV, '9' AS IDTIPOCONS
                          FROM   DIASEMCONS
                          WHERE  CDFILIAL    = :P_CDFILIAL   AND
                                 CDSERVFILI  = :P_CDSERVFILI AND
                                 NRORG       = :P_NRORG      AND 
                                 DTSCONSSERV BETWEEN :P_DTCONSSERV AND :P_ULTIDIAMES AND
                                 IDTCONSSERV = 'A') CONS) DIASEMCONS
                  WHERE DIASEMCONS.DTCONSSERV = DATA.DTDATA
                  ) ORDER BY DTDATA";

        $params = array(
            "P_DTINICIAL"  => $dtInicial,
            "P_CDFILIAL"   => $filial,
            "P_NRORG"      => $nrorg,
            "P_ULTIDIAMES" => $dtFinal,
            "P_DATAFINAL"  => $dtFinal,
            "P_DTCONSSERV" => $dtConsumo,
            "P_CDSERVFILI" => $servico,
        );

        $entityManager = $this->getEntityManager();
        $result = $entityManager->getConnection()->fetchAll($sql, $params);
        return count($result)>0 ? $result : false;
    }

    public function excluiConsumoTipo($nrorg, $filial, $servico, $data, $idDia, $idQtde = null){
        if (empty($idQtde)) {
            $sql = "DELETE FROM CONSSERV
                      WHERE NRORG = :P_NRORG
                        AND DTCONSSERV = :P_DTCONSSERV
                        AND CDFILIAL = :P_CDFILIAL
                        AND CDSERVFILI = :P_CDSERVFILI
                        AND IDTIPOCONS = :P_IDTIPOCONS";

            $params = array(
                "P_NRORG" => $nrorg,
                "P_DTCONSSERV" => $data,
                "P_CDFILIAL" => $filial,
                "P_CDSERVFILI" => $servico,
                "P_IDTIPOCONS" => $idDia,
            );
        } else {
            $sql = "DELETE FROM CONSSERV
                      WHERE NRORG = :P_NRORG
                        AND DTCONSSERV = :P_DTCONSSERV
                        AND CDFILIAL = :P_CDFILIAL
                        AND CDSERVFILI = :P_CDSERVFILI
                        AND IDTIPOCONS = :P_IDTIPOCONS
                        AND IDQTDECONS = :P_IDQTDECONS";

            $params = array(
                "P_NRORG" => $nrorg,
                "P_DTCONSSERV" => $data,
                "P_CDFILIAL" => $filial,
                "P_CDSERVFILI" => $servico,
                "P_IDTIPOCONS" => $idDia,
                "P_IDQTDECONS" => $idQtde,
            );
        }

        try {
            $conn = \Setforms2\Runtime\Connection::getInstance();
            return $conn->execute($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }


    public function retornaConsumoProduto(
        $cdservfili, $cdfilial, $comensaisEstimados, $dtcusto,
        $cdfilicusto, $nrtipocusto, $tipoConsumo
    ){
        $query = "SELECT * FROM (SELECT C.IDCONSUMO AS TIPOCONS, C.CDPRODUTO, C.QTCONSSERV, P.NMPRODUTO, P.SGUNIDADE,
                       CUSTO_PROD_LISTADESATU('$cdfilicusto', C.CDPRODUTO, '$nrtipocusto', '$dtcusto') AS IDCUSTODESATU,
                       CUSTO_PRODUTO('$cdfilicusto', C.CDPRODUTO, '$nrtipocusto', '$dtcusto', SYSDATE) AS CUSTOUNIT,
                       C.QTCONSSERV * CUSTO_PRODUTO('$cdfilicusto', C.CDPRODUTO, '$nrtipocusto', '$dtcusto', SYSDATE) AS CUSTOTOTAL,
                       (C.QTCONSSERV * CUSTO_PRODUTO('$cdfilicusto', C.CDPRODUTO, '$nrtipocusto', '$dtcusto', SYSDATE)) / '$comensaisEstimados' AS CUSTOPERCAPITA
                FROM   (SELECT CS.CDFILIAL, 'F' AS IDCONSUMO, CS.CDPRODUTO, CS.QTCONSSERV
                        FROM   (SELECT C.CDFILIAL, C.IDQTDECONS, C.CDPRODUTO, C.QTCONSSERV
                                FROM   CONSSERV C
                                WHERE  C.CDFILIAL   = '$cdfilial'   AND
                                       C.CDSERVFILI = '$cdservfili' AND
                                       C.DTCONSSERV = '$dtcusto' AND
                                       C.IDTIPOCONS = '9'           AND
                                       C.IDQTDECONS = 'F'           AND
                                       NOT EXISTS (SELECT D.CDFILIAL
                                                   FROM   DIASEMCONS D
                                                   WHERE  D.CDFILIAL    = C.CDFILIAL   AND
                                                          D.CDSERVFILI  = C.CDSERVFILI AND
                                                          D.DTSCONSSERV = C.DTCONSSERV AND
                                                          D.IDTCONSSERV IN ('F','A'))
                                UNION ALL
                                SELECT C.CDFILIAL, C.IDQTDECONS, C.CDPRODUTO, C.QTCONSSERV
                                FROM   CONSSERV C
                                WHERE  C.CDFILIAL   = '$cdfilial'   AND
                                       C.CDSERVFILI = '$cdservfili' AND
                                       C.IDTIPOCONS = '$tipoConsumo' AND
                                       C.IDQTDECONS = 'F'           AND
                                       C.DTCONSSERV = (SELECT MAX(DTCONSSERV)
                                                       FROM   CONSSERV
                                                       WHERE  CDFILIAL    = '$cdfilial'   AND
                                                              CDSERVFILI  = '$cdservfili' AND
                                                              DTCONSSERV <= '$dtcusto' AND
                                                              IDTIPOCONS <> '9') AND
                                       NOT EXISTS (SELECT D.CDFILIAL
                                                   FROM   DIASEMCONS D
                                                   WHERE  D.CDFILIAL    = C.CDFILIAL    AND
                                                          D.CDSERVFILI  = C.CDSERVFILI  AND
                                                          D.DTSCONSSERV = '$dtcusto' AND
                                                          D.IDTCONSSERV IN ('F','A'))   AND
                                       NOT EXISTS (SELECT CS.CDFILIAL
                                                   FROM   CONSSERV CS
                                                   WHERE  CS.CDFILIAL   = C.CDFILIAL    AND
                                                          CS.CDSERVFILI = C.CDSERVFILI  AND
                                                          CS.DTCONSSERV = '$dtcusto' AND
                                                          CS.IDTIPOCONS = '9'           AND
                                                          CS.IDQTDECONS = 'F')) CS, PARAMPLANEJA P
                        WHERE P.CDFILIAL = '$cdfilial' AND
                              P.CDFILIAL = CS.CDFILIAL AND
                              P.CDTPRCONSFIX IS NOT NULL
                        UNION ALL
                        SELECT CS.CDFILIAL, 'P' AS IDCONSUMO, CS.CDPRODUTO, CS.QTCONSSERV
                        FROM   (SELECT C.CDFILIAL, C.IDQTDECONS, C.CDPRODUTO, C.QTCONSSERV
                                FROM   CONSSERV C
                                WHERE  C.CDFILIAL   = '$cdfilial'   AND
                                       C.CDSERVFILI = '$cdservfili' AND
                                       C.DTCONSSERV = '$dtcusto' AND
                                       C.IDTIPOCONS = '9'           AND
                                       C.IDQTDECONS = 'P'           AND
                                       NOT EXISTS (SELECT D.CDFILIAL
                                                   FROM   DIASEMCONS D
                                                   WHERE  D.CDFILIAL    = C.CDFILIAL   AND
                                                          D.CDSERVFILI  = C.CDSERVFILI AND
                                                          D.DTSCONSSERV = C.DTCONSSERV AND
                                                          D.IDTCONSSERV IN ('P','A'))
                                UNION ALL
                                SELECT C.CDFILIAL, C.IDQTDECONS, C.CDPRODUTO, C.QTCONSSERV
                                FROM   CONSSERV C
                                WHERE  C.CDFILIAL   = '$cdfilial'   AND
                                       C.CDSERVFILI = '$cdservfili' AND
                                       C.IDTIPOCONS = '$tipoConsumo' AND
                                       C.IDQTDECONS = 'P'           AND
                                       C.DTCONSSERV = (SELECT MAX(DTCONSSERV)
                                                       FROM   CONSSERV
                                                       WHERE  CDFILIAL    = '$cdfilial'    AND
                                                              CDSERVFILI  = '$cdservfili'  AND
                                                              DTCONSSERV <= '$dtcusto'  AND
                                                              IDTIPOCONS <> '9')   AND
                                       NOT EXISTS (SELECT D.CDFILIAL
                                                   FROM   DIASEMCONS D
                                                   WHERE  D.CDFILIAL    = C.CDFILIAL    AND
                                                          D.CDSERVFILI  = C.CDSERVFILI  AND
                                                          D.DTSCONSSERV = '$dtcusto' AND
                                                          D.IDTCONSSERV IN ('P','A'))   AND
                                       NOT EXISTS (SELECT CS.CDFILIAL
                                                   FROM   CONSSERV CS
                                                   WHERE  CS.CDFILIAL   = C.CDFILIAL    AND
                                                          CS.CDSERVFILI = C.CDSERVFILI  AND
                                                          CS.DTCONSSERV = '$dtcusto' AND
                                                          CS.IDTIPOCONS = '9'           AND
                                                          CS.IDQTDECONS = 'P')) CS, PARAMPLANEJA P
                        WHERE P.CDFILIAL = '$cdfilial' AND
                              P.CDFILIAL = CS.CDFILIAL AND
                              P.CDTPRCONSPER IS NOT NULL) C, PRODUTO P
                WHERE C.CDPRODUTO = P.CDPRODUTO )
                ORDER BY NMPRODUTO";

        $entityManager = $this->getEntityManager();
        $result = $entityManager->getConnection()->fetchAll($query);

        return $result;
    }
    
    
}