<?php

/**
 * GepProdutosoli
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     alessandrobartels - 04/05/2011 10:30:28 <development@setforms.com>
 * @version    Release: SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class GepProdutosoli extends DaoGepProdutosoli
{


    /**      ok
     * Consulta produto de uma determinada solicitacao.
     *
     * @param integer $nrorg         N?mero da Organizacao.
     * @param integer $nrsolicitacao N?mero da Solicitacao.
     *
     * @return string $obj           Retorna um registro se houver.
     */
    public static function consultaProdutoSoli($nrorg, $nrsolicitacao){
        try {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND NRSOLICITACAO = ? ',
                array(
                 $nrorg,
                 $nrsolicitacao,
                )
            );
            return $obj;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**     ok
     * Consulta os produtos de uma determinada solicitacao.
     *
     * @param integer $nrorg         Numero da Organizacao.
     * @param integer $nrsolicitacao Numero da Solicitacao.
     *
     * @return string $obj          Retorna mais de um registro se houver.
     */
    public static function consultaListaProdutoSoli($nrorg, $nrsolicitacao){
        try {
            $obj = self::getObjectsByWhere(
                'NRORG = ? AND NRSOLICITACAO = ?',
                array(
                 $nrorg,
                 $nrsolicitacao,
                )
            );
            return $obj;
        } catch (Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Exclui todos os produtos de uma determinada solicita??o.
     *
     * @param integer $solicitacao N?mero da Solicita??o.
     * @param integer $nrorg       N?mero da Organiza??o.
     *
     * @return boolean
     */
    public static function excluiProdutoSoli($solicitacao, $nrorg){
        try {
            $db = TkDbAdapter::getWorkConnection();

            $exclusao = $db->createQuery()
                ->delete('GEP_PRODUTOSOLI')
                ->where("NRORG = '".$nrorg."'")
                ->addWhere("NRSOLICITACAO = '".$solicitacao."'");
            $db->execute($exclusao);
        } catch(Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
        return true;
    }


}