/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PERIENTR                                                 */
/* Tabela : PERIENTR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 20/07/2000 - Joo Fernando dos Reis Corra                                 */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PERIENTR
BEFORE INSERT OR UPDATE OR DELETE
ON PERIENTR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPER := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPERIENTR,0) <> NVL(:NEW.CDPERIENTR,0)) OR
         (NVL(:OLD.NMPERIENTR,0) <> NVL(:NEW.NMPERIENTR,0)) OR
         (NVL(:OLD.IDDIANUTIL,0) <> NVL(:NEW.IDDIANUTIL,0)) OR
         (NVL(:OLD.IDTIPODIA,0) <> NVL(:NEW.IDTIPODIA,0)) THEN
         :NEW.DTULTATUPER := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PERIENTR', '', 'CDPERIENTR='||:OLD.CDPERIENTR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PERIENTR MODIFY DTULTATUPER DEFAULT SYSDATE
/
